import { Mqtt } from './mqtt'
export let mqttInstants: Mqtt

export function InitMqtt(config?: {
  host: string
  port: number
  username?: string | undefined
  password?: string
  path?: string
  use?: boolean
}) {
  // 设置默认配置
  const defaultConfig = {
    host: '192.168.0.119',
    port: 8083,
    username: 'admin',
    password: 'public',
    path: '/mqtt',
    use: true,
  }

  // 合并用户传入的配置与默认配置
  const mqttConfig = {
    ...defaultConfig,
    ...(config || {}),
  }

  if (mqttConfig.use) {
    // 确保 username 和 password 为 string 类型
    const username = mqttConfig.username || defaultConfig.username
    const password = mqttConfig.password || defaultConfig.password

    // 初始化 Mqtt 实例
    mqttInstants = new Mqtt(mqttConfig.host, mqttConfig.port, username, password, mqttConfig.path)
  } else {
    console.error('MQTT is disabled in the configuration.')
  }
}
